diff --git a/game/core/src/main/java/net/minecraft/core/player/gamemode/GamemodeBuilder.java b/game/core/src/main/java/net/minecraft/core/player/gamemode/GamemodeBuilder.java
new file mode 100644
index 000000000..8ecbcb55a
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/player/gamemode/GamemodeBuilder.java
@@ -0,0 +1,185 @@
+package net.minecraft.core.player.gamemode;
+
+import net.minecraft.core.player.inventory.container.ContainerInventory;
+import net.minecraft.core.player.inventory.menu.MenuInventory;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.function.Function;
+
+/**
+ * Used to construct an instance of {@link net.minecraft.core.player.gamemode.Gamemode Gamemode}.
+ */
+public class GamemodeBuilder {
+    private final @NotNull String languageKey;
+    private final @NotNull Function<@NotNull ContainerInventory, @NotNull MenuInventory> inventoryMenuSupplier;
+
+    private boolean invulnerablePlayer = false;
+    private boolean playerFlight = false;
+    private boolean blockConsumption = false;
+    private boolean blockBreakingAnimation = false;
+    private boolean toolDurability = false;
+    private boolean itemDrops = false;
+    private boolean hostileMobs = false;
+    private boolean fireImmunity = false;
+    private boolean instantPortalTravel = false;
+    private boolean properToolNeededToMine = false;
+    private boolean canInteract = true;
+    private boolean permaDeath = false;
+    private float blockReachDistance = 4.5f;
+    private float entityReachDistance = 3.0f;
+
+    public GamemodeBuilder(
+        final @NotNull String languageKey,
+        final @NotNull Function<@NotNull ContainerInventory, @NotNull MenuInventory> inventoryMenuSupplier
+    ) {
+        this.languageKey = languageKey;
+        this.inventoryMenuSupplier = inventoryMenuSupplier;
+    }
+
+    public @NotNull Gamemode build() {
+        return new Gamemode(
+            this.languageKey,
+            this.inventoryMenuSupplier,
+            this.invulnerablePlayer,
+            this.playerFlight,
+            this.blockConsumption,
+            this.blockBreakingAnimation,
+            this.toolDurability,
+            this.itemDrops,
+            this.hostileMobs,
+            this.fireImmunity,
+            this.instantPortalTravel,
+            this.properToolNeededToMine,
+            this.canInteract,
+            this.permaDeath,
+            this.blockReachDistance,
+            this.entityReachDistance
+        );
+    }
+
+    /**
+     * Sets the player to be invulnerable.
+     * @see Gamemode#hasInvulnerablePlayer()
+     */
+    public @NotNull GamemodeBuilder withInvulnerablePlayer() {
+        this.invulnerablePlayer = true;
+        return this;
+    }
+
+    /**
+     * Sets the player to be able to fly.
+     * @see Gamemode#hasPlayerFlight()
+     */
+    public @NotNull GamemodeBuilder withPlayerFlight() {
+        this.playerFlight = true;
+        return this;
+    }
+
+    /**
+     * Sets the player to consume blocks on place.
+     * @see Gamemode#hasBlockConsumption()
+     */
+    public @NotNull GamemodeBuilder withBlockConsumption() {
+        this.blockConsumption = true;
+        return this;
+    }
+
+    /**
+     * Sets the player to break blocks with an animation.
+     * @see Gamemode#hasBlockBreakingAnimation()
+     */
+    public @NotNull GamemodeBuilder withBlockBreakingAnimation() {
+        this.blockBreakingAnimation = true;
+        return this;
+    }
+
+    /**
+     * Sets the player's tools to take durability damage.
+     * @see Gamemode#hasToolDurability()
+     */
+    public @NotNull GamemodeBuilder withToolDurability() {
+        this.toolDurability = true;
+        return this;
+    }
+
+    /**
+     * Sets blocks to drop items when mined by the player.
+     * @see Gamemode#hasItemDrops()
+     */
+    public @NotNull GamemodeBuilder withItemDrops() {
+        this.itemDrops = true;
+        return this;
+    }
+
+    /**
+     * Sets mobs to be hostile to the player.
+     * @see Gamemode#hasHostileMobs()
+     */
+    public @NotNull GamemodeBuilder withHostileMobs() {
+        this.hostileMobs = true;
+        return this;
+    }
+
+    /**
+     * Sets the player to be immune to fire.
+     * @see Gamemode#hasFireImmunity()
+     */
+    public @NotNull GamemodeBuilder withFireImmunity() {
+        this.fireImmunity = true;
+        return this;
+    }
+
+    /**
+     * Sets the player to travel through portals instantly.
+     * @see Gamemode#hasInstantPortalTravel()
+     */
+    public @NotNull GamemodeBuilder withInstantPortalTravel() {
+        this.instantPortalTravel = true;
+        return this;
+    }
+
+    /**
+     * Sets the player's block reach distance.
+     * @see Gamemode#getBlockReachDistance()
+     */
+    public @NotNull GamemodeBuilder withBlockReachDistance(final float blockReachDistance) {
+        this.blockReachDistance = blockReachDistance;
+        return this;
+    }
+
+    /**
+     * Sets the player's entity reach distance.
+     * @see Gamemode#getEntityReachDistance()
+     */
+    public @NotNull GamemodeBuilder withEntityReachDistance(final float entityReachDistance) {
+        this.entityReachDistance = entityReachDistance;
+        return this;
+    }
+
+    /**
+     * Sets that the player needs the correct tool to mine blocks.
+     * @see Gamemode#isProperToolNeededToMine()
+     */
+    public @NotNull GamemodeBuilder withProperToolNeededToMine() {
+        this.properToolNeededToMine = true;
+        return this;
+    }
+
+    /**
+     * Sets that the player cannot interact with mobs or items.
+     * @see Gamemode#canInteract()
+     */
+    public @NotNull GamemodeBuilder withNoInteraction() {
+        this.canInteract = false;
+        return this;
+    }
+
+    /**
+     * Sets that the player cannot respawn on death.
+     * @see Gamemode#hasPermaDeath()
+     */
+    public @NotNull GamemodeBuilder withPermaDeath() {
+        this.permaDeath = true;
+        return this;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/player/gamemode/Gamemodes.java b/game/core/src/main/java/net/minecraft/core/player/gamemode/Gamemodes.java
new file mode 100644
index 000000000..5ab6818c3
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/player/gamemode/Gamemodes.java
@@ -0,0 +1,109 @@
+package net.minecraft.core.player.gamemode;
+
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
+import net.minecraft.core.player.inventory.menu.MenuInventory;
+import net.minecraft.core.player.inventory.menu.MenuInventoryCreative;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public final class Gamemodes {
+    /**
+     * The default gamemode. Players will be forced to survive in the wilderness, collecting blocks and items and
+     * fighting monsters.
+     */
+    public static final @NotNull Gamemode SURVIVAL = register("minecraft:gamemode/survival",
+        new GamemodeBuilder("gamemode.survival", Gamemodes::survivalInventory)
+            .withBlockConsumption()
+            .withBlockBreakingAnimation()
+            .withToolDurability()
+            .withItemDrops()
+            .withHostileMobs()
+            .build()
+    );
+
+    /**
+     * Minecraft's original gamemode. Players are invulnerable and have unlimited access to blocks and items.
+     */
+    public static final @NotNull Gamemode CREATIVE = register("minecraft:gamemode/creative",
+        new GamemodeBuilder("gamemode.creative", Gamemodes::creativeInventory)
+            .withInvulnerablePlayer()
+            .withPlayerFlight()
+            .withFireImmunity()
+            .withInstantPortalTravel()
+            .withBlockReachDistance(6.0f)
+            .withEntityReachDistance(4.5f)
+            .build()
+    );
+
+    /**
+     * Identical to {@link Gamemodes#SURVIVAL} but the player must delete their world on death.
+     */
+    public static final @NotNull Gamemode HARDCORE = register("minecraft:gamemode/hardcore",
+        new GamemodeBuilder("gamemode.hardcore", Gamemodes::survivalInventory)
+            .withBlockConsumption()
+            .withBlockBreakingAnimation()
+            .withToolDurability()
+            .withItemDrops()
+            .withHostileMobs()
+            .withPermaDeath()
+            .build()
+    );
+
+    /**
+     * Identical to {@link Gamemodes#SURVIVAL} but the player can only break blocks with the proper tool.
+     */
+    public static final @NotNull Gamemode ADVENTURE = register("minecraft:gamemode/adventure",
+        new GamemodeBuilder("gamemode.adventure", Gamemodes::survivalInventory)
+            .withBlockConsumption()
+            .withBlockBreakingAnimation()
+            .withToolDurability()
+            .withItemDrops()
+            .withHostileMobs()
+            .withProperToolNeededToMine()
+            .build()
+    );
+
+    /**
+     * The player is a ghost - they cannot be seen or heard, and cannot have any impact on the world.
+     */
+    public static final @NotNull Gamemode SPECTATOR = register("minecraft:gamemode/spectator",
+        new GamemodeBuilder("gamemode.spectator", Gamemodes::survivalInventory)
+            .withInvulnerablePlayer()
+            .withPlayerFlight()
+            .withFireImmunity()
+            .withInstantPortalTravel()
+            .withBlockReachDistance(5000)
+            .withEntityReachDistance(5000)
+            .withNoInteraction()
+            .build()
+    );
+
+    public static @NotNull Gamemode register(final @NotNull String id, final @NotNull Gamemode gamemode) {
+        Registries.GAMEMODES.register(id, gamemode);
+        return gamemode;
+    }
+
+    public static void init() { }
+
+    public static @Nullable Gamemode getGamemodeByLegacyId(final int id) {
+        return switch (id) {
+            case 0 -> SURVIVAL;
+            case 1 -> CREATIVE;
+            case 2 -> HARDCORE;
+            case 3 -> ADVENTURE;
+            case 4 -> SPECTATOR;
+            default -> null;
+        };
+    }
+
+    private static @NotNull MenuInventory survivalInventory(final @NotNull ContainerInventory inventory) {
+        return new MenuInventory(inventory);
+    }
+
+    private static @NotNull MenuInventory creativeInventory(final @NotNull ContainerInventory inventory) {
+        return new MenuInventoryCreative(inventory);
+    }
+
+    private Gamemodes() { }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java
index 357d36376..123bf68aa 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java
@@ -2,30 +2,75 @@ package net.minecraft.core.player.inventory.container;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import net.minecraft.core.item.Item;
 
-public interface Container
-{
-
+/**
+ * Models a container, which holds a set of {@link ItemStack ItemStack}s.
+ */
+public interface Container {
+    /**
+     * Fetches the total size of the container in slots.
+     */
     int getContainerSize();
 
-    @Nullable ItemStack getItem(int index);
+    /**
+     * Fetches the {@link ItemStack} at the given slot.
+     * @param slot The slot to fetch the item from.
+     */
+    @Nullable ItemStack getItem(int slot);
 
-    @Nullable ItemStack removeItem(int index, int takeAmount);
+    /**
+     * Removes {@code takeAmount} quantity of items from the given slot, effectively splitting the {@link ItemStack} in
+     * that slot.
+     * <br><br>
+     * For example, if {@code takeAmount} was 2 and the {@code stackSize} of the {@link ItemStack} was 5, an
+     * {@link ItemStack} identical to the {@link ItemStack} in the slot would be returned, but with a {@code stackSize}
+     * of 2. The {@code stackSize} of the original {@link ItemStack} would be set to 3.
+     * @param slot The slot to take items from.
+     * @return A new {@link ItemStack}, or {@code null} if the slot was empty.
+     */
+    @Nullable ItemStack removeItem(int slot, int takeAmount);
 
-    void setItem(int index, @Nullable ItemStack itemstack);
+    /**
+     * Overwrites the {@link ItemStack} in the given slot with {@code stack}.
+     * @param slot The slot to overwrite.
+     * @param stack The stack to insert.
+     */
+    void setItem(int slot, @Nullable ItemStack stack);
 
-    String getNameTranslationKey();
+    /**
+     * Fetches the translation key for the container.
+     */
+    @NotNull String getNameTranslationKey();
 
+    /**
+     * The maximum stack size for any given slot in the container. The "true" stack size for any given slot is the
+     * minimum of this and {@link Item#getItemStackLimit(ItemStack)}.
+     */
     int getMaxStackSize();
 
+    /**
+     * Called whenever a slot in the container is changed somehow.
+     */
     void setChanged();
 
-    boolean stillValid(Player entityplayer);
+    /**
+     * Determines whether the container view is still valid. If it is invalid, it should be closed immediately.
+     * @param player The player viewing the container.
+     */
+    boolean stillValid(@NotNull Player player);
 
-    void sortContainer();
+    /**
+     * Sorts the contents of the container.
+     */
+    void sort();
 
-    default boolean locked(int index) {
+    /**
+     * Determines whether the given slot has been locked and cannot be modified.
+     */
+    default boolean locked(final int slot) {
         return false;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java
index b9896ff91..5b04596d1 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java
@@ -3,98 +3,127 @@ package net.minecraft.core.player.inventory.container;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.InventorySorter;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ContainerCompound
-    implements Container
-{
-    private String name;
-    private Container c1;
-    private Container c2;
-
-    public ContainerCompound(String s, Container c1, Container c2)
-    {
-        name = s;
-        this.c1 = c1;
-        this.c2 = c2;
+    implements Container {
+    private final @NotNull String name;
+    private final @NotNull Container @NotNull [] containers;
+
+    public ContainerCompound(final @NotNull String name, final @NotNull Container @NotNull... containers) {
+        this.name = name;
+        this.containers = containers;
+
+        if (this.containers.length == 0) {
+            throw new IllegalArgumentException("Cannot create an empty compound!");
+        }
     }
 
     @Override
-	public int getContainerSize()
-    {
-        return c1.getContainerSize() + c2.getContainerSize();
+    public int getContainerSize() {
+        int sum = 0;
+        for (final @NotNull Container container : this.containers) {
+            sum += container.getContainerSize();
+        }
+
+        return sum;
     }
 
     @Override
-	public String getNameTranslationKey()
-    {
-        return name;
+    public @NotNull String getNameTranslationKey() {
+        return this.name;
     }
 
     @Override
-	public @Nullable ItemStack getItem(int index)
-    {
-        if(index >= c1.getContainerSize())
-        {
-            return c2.getItem(index - c1.getContainerSize());
-        } else
-        {
-            return c1.getItem(index);
+    public @Nullable ItemStack getItem(final int slot) {
+        if (slot < 0) {
+            return null;
         }
+
+        int sum = 0;
+        for (final @NotNull Container container : this.containers) {
+            if (slot < sum + container.getContainerSize()) {
+                return container.getItem(slot - sum);
+            }
+
+            sum += container.getContainerSize();
+        }
+
+        return null;
     }
 
     @Override
-	public @Nullable ItemStack removeItem(int index, int takeAmount)
-    {
-        if(index >= c1.getContainerSize())
-        {
-            return c2.removeItem(index - c1.getContainerSize(), takeAmount);
-        } else
-        {
-            return c1.removeItem(index, takeAmount);
+    public @Nullable ItemStack removeItem(final int slot, final int takeAmount) {
+        if (slot < 0) {
+            return null;
         }
+
+        int sum = 0;
+        for (final @NotNull Container container : this.containers) {
+            if (slot < sum + container.getContainerSize()) {
+                return container.removeItem(slot - sum, takeAmount);
+            }
+
+            sum += container.getContainerSize();
+        }
+
+        return null;
     }
 
     @Override
-	public void setItem(int index, @Nullable ItemStack itemstack)
-    {
-        if(index >= c1.getContainerSize())
-        {
-            c2.setItem(index - c1.getContainerSize(), itemstack);
-        } else
-        {
-            c1.setItem(index, itemstack);
+    public void setItem(final int slot, final @Nullable ItemStack stack) {
+        if (slot < 0) {
+            return;
+        }
+
+        int sum = 0;
+        for (final @NotNull Container container : this.containers) {
+            if (slot < sum + container.getContainerSize()) {
+                container.setItem(slot - sum, stack);
+                break;
+            }
+
+            sum += container.getContainerSize();
         }
     }
 
     @Override
-	public int getMaxStackSize()
-    {
-        return c1.getMaxStackSize();
+    public int getMaxStackSize() {
+        return this.containers[0].getMaxStackSize();
     }
 
     @Override
-	public void setChanged()
-    {
-        c1.setChanged();
-        c2.setChanged();
+    public void setChanged() {
+        for (final @NotNull Container container : this.containers) {
+            container.setChanged();
+        }
     }
 
     @Override
-	public boolean stillValid(Player entityplayer)
-    {
-        return c1.stillValid(entityplayer) && c2.stillValid(entityplayer);
+    public boolean stillValid(final @NotNull Player player) {
+        boolean invalid = false;
+        for (final @NotNull Container container : this.containers) {
+            invalid |= !container.stillValid(player);
+        }
+
+        return !invalid;
     }
 
     @Override
-    public void sortContainer() {
-        ItemStack[] itemStacks = new ItemStack[getContainerSize()];
+    public void sort() {
+        // Create unified copy of joined inventory
+        final @Nullable ItemStack @NotNull [] itemStacks = new ItemStack[this.getContainerSize()];
         for (int i = 0; i < itemStacks.length; i++) {
-            itemStacks[i] = getItem(i);
+            itemStacks[i] = this.getItem(i);
         }
+
+        // Sort unified copy
         InventorySorter.sortInventory(itemStacks);
+
+        // Copy unified copy back into joined inventory
         for (int i = 0; i < itemStacks.length; i++) {
-            setItem(i, itemStacks[i]);
+            this.setItem(i, itemStacks[i]);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java
index 9e806cdcd..226fdaaa5 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java
@@ -3,123 +3,97 @@ package net.minecraft.core.player.inventory.container;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.menu.MenuAbstract;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ContainerCrafting
-    implements Container
-{
-    private ItemStack[] items;
-    private int width;
-    private MenuAbstract menu;
+    implements Container {
+    private final @NotNull MenuAbstract menu;
+    private final int xSize;
+    private final @Nullable ItemStack @NotNull [] items;
 
-    public ContainerCrafting(MenuAbstract container, int width, int n)
-    {
-        int k = width * n;
-        items = new ItemStack[k];
-        menu = container;
-        this.width = width;
+    public ContainerCrafting(final @NotNull MenuAbstract menu, final int xSize, final int ySize) {
+        this.menu = menu;
+        this.xSize = xSize;
+        this.items = new ItemStack[xSize * ySize];
     }
 
     @Override
-	public int getContainerSize()
-    {
-        return items.length;
+    public int getContainerSize() {
+        return this.items.length;
     }
 
     @Override
-	public @Nullable ItemStack getItem(int index)
-    {
-        if(index >= getContainerSize())
-        {
+    public @Nullable ItemStack getItem(final int slot) {
+        if (slot >= this.getContainerSize()) {
             return null;
-        } else
-        {
-            return items[index];
+        } else {
+            return this.items[slot];
         }
     }
 
-    public ItemStack getItemStackAt(int i, int j)
-    {
-        if(i < 0 || i >= width)
-        {
+    public @Nullable ItemStack getItemStackAt(final int x, final int y) {
+        if (x < 0 || x >= this.xSize) {
             return null;
-        } else
-        {
-            int k = i + j * width;
-            return getItem(k);
+        } else {
+            return this.getItem(x + y * this.xSize);
         }
     }
 
-    public void setSlotContentsAt(int i, int j, ItemStack itemStack)
-    {
-        if(i < 0 || i >= width)
-        {
-            return;
-        } else
-        {
-            int k = i + j * width;
-            setItem(k, itemStack);
+    public void setSlotContentsAt(final int x, final int y, final @Nullable ItemStack stack) {
+        if (x >= 0 && x < this.xSize) {
+            this.setItem(x + y * this.xSize, stack);
         }
     }
 
     @Override
-	public String getNameTranslationKey()
-    {
+    public @NotNull String getNameTranslationKey() {
         return "container.crafting.name";
     }
 
     @Override
-	public @Nullable ItemStack removeItem(int index, int takeAmount)
-    {
-        if(items[index] != null)
-        {
-            if(items[index].stackSize <= takeAmount)
-            {
-                ItemStack itemstack = items[index];
-                items[index] = null;
-                menu.slotsChanged(this);
-                return itemstack;
+    public @Nullable ItemStack removeItem(final int slot, final int takeAmount) {
+        final @Nullable ItemStack currentItem = this.items[slot];
+        if (currentItem != null) {
+            if (currentItem.stackSize <= takeAmount) {
+                this.items[slot] = null;
+                this.menu.slotsChanged(this);
+                return currentItem;
             }
-            ItemStack itemstack1 = items[index].splitStack(takeAmount);
-            if(items[index].stackSize <= 0)
-            {
-                items[index] = null;
+            final @NotNull ItemStack otherHalf = currentItem.splitStack(takeAmount);
+            if (currentItem.stackSize <= 0) {
+                this.items[slot] = null;
             }
-            menu.slotsChanged(this);
-            return itemstack1;
-        } else
-        {
+            this.menu.slotsChanged(this);
+            return otherHalf;
+        } else {
             return null;
         }
     }
 
     @Override
-	public void setItem(int index, @Nullable ItemStack itemstack)
-    {
-        items[index] = itemstack;
-        menu.slotsChanged(this);
+    public void setItem(final int slot, final @Nullable ItemStack stack) {
+        this.items[slot] = stack;
+        this.menu.slotsChanged(this);
     }
 
     @Override
-	public int getMaxStackSize()
-    {
+    public int getMaxStackSize() {
         return 64;
     }
 
     @Override
-	public void setChanged()
-    {
-        menu.slotsChanged(this);
+    public void setChanged() {
+        this.menu.slotsChanged(this);
     }
 
     @Override
-	public boolean stillValid(Player entityplayer)
-    {
+    public boolean stillValid(final @NotNull Player player) {
         return true;
     }
 
     @Override
-    public void sortContainer() {
+    public void sort() {
         // Do nothing
     }
 }
